[二分、贪心]Codeforces Round #307 (Div. 2) C.GukiZ hates Boxes

教授GukiZ面临被箱子挡住去学校的困境,有n堆箱子和m名学生帮忙。每名学生按顺序移除箱子,需要确定最少需要多少时间才能清空所有箱子。这个问题可以通过二分搜索和贪心策略在O(nlogS)的时间复杂度内求解。
摘要由CSDN通过智能技术生成
H - GukiZ hates Boxes
Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u

Description

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are n piles of boxes, arranged in a line, from left to right, i-th pile (1 ≤ i ≤ n) containing ai boxes. Luckily, m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

  1. If i ≠ n, move from pile i to pile i + 1;
  2. If pile located at the position of student is not empty, remove one box from it.

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time t in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after t seconds, but all the boxes must be removed.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 105), the number of piles of boxes and the number of GukiZ's students.

The second line contains n integers a1, a2, ... an (0 ≤ ai ≤ 109) where ai represents the number of boxes on i-th pile. It's guaranteed that at least one pile of is non-empty.

Output

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

Sample Input

Input
2 1
1 1
Output
4
Input
3 2
1 0 2
Output
5
Input
4 100
3 4 5 4
Output
5

Hint

First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.


假设最后一个非零的位置为K,所有位置上的和为S

      那么答案的范围在[K+1,K+S].

      二分这个答案ans,然后对每个人尽量在ans时间内搬最多的砖.可以得出至少需要多少个人才能搬完.这个可以在O(n)的时间内利用贪心得到

      只要判断需要的人数是否小于等于实际的人数就好了

      时间复杂度O(nlogS)


#include <iostream>
#include<cstdio>
using namespace std;

long long a[100050];
    int n,m;
    long long ans,sum;
    long long st,ed;
int Check(long long x)
{
    int cnt = m; //学生数量
    long long sum = 0; 
    for(int i = 1; i<=st; i++)
    {
        sum+=a[i]; //总箱子个数 第i个位置
        while(sum+i>=x)  //当箱子总数加上位置大于时间x时
        {
            sum-=x-i;  //移动到了x-i位置以后,每增加一个学生就可以搬走一个箱子
            cnt--;  
            if(cnt<0) return 0;
        }
    }
    if(cnt==0)
    {
        if (sum <= 0) return 1;
        else return 0;
    }
    return 1;
}

int main()
{

    while(cin>>n>>m)
    {
        sum = 0;
        for(int i =1; i<=n;i++)
        {
            scanf("%I64d",&a[i]);
            if(a[i]!=0)
                st = i;
            sum += a[i];
        }
        ed = st + sum;
        long long L = st,R=ed;
        while(L<=R)
        {
            long long mid =(L+R)/2;
            if(Check(mid))
            {
                ans = mid;
                R = mid - 1;
            }
            else
            {
                L = mid + 1;
            }
        }
        cout<<ans<<endl;
    }
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值